package org.illeva.jordino.answer;

import javax.mail.*;
import javax.mail.internet.*;

/**
  * This class builds the appropriate response message from an answer.
  *
  * @since Jordino Version 1.0
  * @author IlLeva
  */
public class AnswerFactory
{
  // Data
  private MimeMessage dResponse=null;
  private MimeMessage dOrigin=null;
  // Methods;
  /** Return the appropriate response to message. */
  public MimeMessage getResponse()
  {
    if(dResponse==null)
      dResponse=(new UnknowCommand(dOrigin)).getMessage();
    return dResponse;
  } // end getMessage
  /**
    * Defaul constructor.
    */
  public AnswerFactory()
  {
  } // end constructor
  /**
    * Matches the Message with the correct answer.
    */
  public MimeMessage run(MimeMessage aMsg)
  {
    dResponse=null;
    dOrigin=aMsg;
    if(dOrigin!=null)
      try
      {
        if(dOrigin.getSubject().indexOf("[JD Ping")!=-1)
        {
          dResponse=(new Ping(dOrigin)).getMessage();
        } // end if
        else if(dOrigin.getSubject().indexOf("[JD Help")!=-1)
        {
          dResponse=(new Help(dOrigin)).getMessage();
        } // end elseIf
        else
        {
          dResponse=(new UnknowCommand(dOrigin)).getMessage();
        } // end else
      } // end try
      catch(MessagingException anEx)
      {
        System.err.println(anEx);
      } // end catch
    return dResponse;
  } // end run
} // end class