package org.illeva.jordino.gui;

import java.awt.*;
import java.awt.event.*;

import org.illeva.jordino.core.*;

/**
  * This is the simplest gui for Jordino.<BR>
  * It's not very good. I apologise but it's a demo.
  * @version Jordino V1.0
  * @author IlLeva
  */
public class JordinoMainWin extends Frame implements WindowListener, ActionListener
{
  /* No graphic elements */
  MessageQueue dQueue=new MessageQueue();
    MailReader dReader;
    WatchDog dWatcher;
    /* graphic elements */
    private Button dBtnTurn= new Button("Start");
    private LabelList dListProc=new LabelList("Processed");
    // private LabelList dListSkip=new LabelList("Skipped");
    private LabelList dListErr=new LabelList("Errors");
    /**
      * Builds a simple gui to start and stop process.
      * @version Jordino V1.0
  * @author IlLeva
      */
    public JordinoMainWin()
    {
      super("Jordino V1.0");
      add(dListProc, BorderLayout.WEST);
      // add(dListSkip, BorderLayout.CENTER);
      add(dListErr, BorderLayout.EAST);
    add(dBtnTurn, BorderLayout.SOUTH);
    addWindowListener(this);
    dBtnTurn.addActionListener(this);
    } // end constructor
  /* Handling events window */
  /**
    * If user closes window , this function stops the threads.
    * @version Jordino V1.0
  * @author IlLeva
    */
  public void windowClosing(WindowEvent anEvent)
  {
    if(dBtnTurn.getLabel().equals("Stop"))
      closeThreads();
    System.exit(0);
  } // End of method
  public void windowClosed(WindowEvent anEvent)
  {
    // System.err.println(anEvent);
  } // End of method
  public void windowOpened(WindowEvent anEvent)
  {
    // System.err.println(anEvent);
  } // End of method
  public void windowIconified(WindowEvent anEvent)
  {
    // System.err.println(anEvent);
  } // End of method
  public void windowDeiconified(WindowEvent anEvent)
  {
    // System.err.println(anEvent);
  } // End of method
  public void windowActivated(WindowEvent anEvent)
  {
    // System.err.println(anEvent);
  } // End of method
  public void windowDeactivated(WindowEvent anEvent)
  {
    // System.err.println(anEvent);
  } // End of method
  /**
    * Process the button event (start and stop).
    * @version Jordino V1.0
  * @author IlLeva
    */
  public void actionPerformed(ActionEvent anEvent)
  {
    System.out.println(anEvent.getActionCommand());
    if(anEvent.getActionCommand().equals("Start"))
    {
      dReader=new MailReader(dQueue);
      dReader.setSemaphore(true);
      dReader.start();
      dWatcher=new WatchDog(dQueue);
      dWatcher.setSemaphore(true);
      dWatcher.start();
      dBtnTurn.setLabel("Stop");
    }
    else if(anEvent.getActionCommand().equals("Stop"))
    {
      closeThreads();
      dBtnTurn.setLabel("Start");
    } // end if
    else
      System.err.println(anEvent);
  } // End of method
  private void closeThreads()
  {
    dWatcher.setSemaphore(false);
    dWatcher.interrupt();
    dReader.setSemaphore(false);
    dReader.interrupt();
  } // end method
} // end class